Module NLTE_inp
  Type NLTE_input
!
! Elim2=When to stop iterating (e.g., 1e-3)
! Elim1=When to stop updating the rate matrix E (e.g., same as Elim2)
! QNORM=Typical Doppler width (in km/s) used to define frequency 
!                                units (e.g., 8)
! NMU=Number of points to use in angular quadrature (e.g., 3)
! VelFree=Whether or not to use the Velocity-free approximation
! CPER=Artificial enhancment of collisional rates. Should be 1. Setting it 
!          to a large value results in LTE populations. May be useful for
!          debugging or investigating issues.
! VirtualFiles=Large arrays containing opacities, profile and radiation field
!          information may be stored in memory (virtual files) or disk.
!          Using virtual files is much faster, but some large computations
!          may demand disk files.
! NGacc=Whether or not to use NG acceleration (e.g., .TRUE.)
! MaxIters=Maximum number of allowed iterations in solvestat (e.g.,200)
! ISum=As in MULTI, number of equation to replace with particle conservation 
!          equation. If zero, pick the level with the largest population.
!          I've found that 1 usually yields best results.
! Verbose=Verbosity level
! Write=Write pop.dat and ltepop.dat files containing atomic populations
!
     Real :: elim1, elim2, QNORM, CPER
     Integer :: NMU, MaxIters, Verbose, ISum
     Logical :: VelFree, VirtualFiles, NGacc, Write
  End Type NLTE_input
End Module NLTE_inp
