      SUBROUTINE STATP(IDEP,IHTOT)
C
C*******************************************************************
C
C STATP finds H_0, H+, H- atoms, and  H2+, H2 molecules 
C       density RHO  and total number of hydrogen atoms HTOT 
C       are found from model P_gas and P_e
C
C
C IHTOT=-1  without molecules
C IHTOT=-2  with molecules 
C
C NB !   Results are not sensitive to chemical composition   
C
C*****************************************************************
C
C           INCLUDE 'PARAMAX'
C
      IMPLICIT REAL*8(G,Q)                                              
      PARAMETER (MDEP=1,MK=1,MFT=1)   
      DOUBLE PRECISION SUM,XMU,AA,BB,UHYD,Y                             
      DOUBLE PRECISION FH,FZE,F1,F2,F3,F4,F5,C1,C2,C3                   
      LOGICAL PHOTO                                                     
      REAL NHYD,NP,NE,NATOM,M                                           
      REAL*8 NLEVEL                                                     
      
      DIMENSION V(10300),BM(MDEP,30),DQI(30,MDEP),DQ(MDEP),DH2P(MDEP),DH
     & (MDEP),DHM(MDEP),NE(MDEP),TEMP(MDEP),PE(MDEP),NATOM(MDEP),M(MDEP)
     &     ,RHO(MDEP),CHIE(MFT),SIG(MFT),FREQ(MFT),WT(MFT),PHOTO(MFT)
     &     ,NXTION(MK),BNU(MFT),HTOT(MDEP),NHYD(5,MDEP),NP(MDEP)
      
      DIMENSION NELEM(1),KU(1),KEL(1)                                   
      DIMENSION QA(25),TO(25),UO(25),U(2)                               
      DIMENSION ELMENT(25),ALFA(25),AS(25),CHIO(25)                     
      DIMENSION NBELO1(2,25),NTO1(2,25),TO1(248),UO1(248)               
      DIMENSION NLEVEL(30),EXO1(30),GO1(30)               
      DIMENSION QI(30)                                        
      
      COMMON V
C
      COMMON/BION/ BM
C                                                   
      COMMON /EQION/ DQI,DQ,DH2P,
     ,DH,DHM
C          
      COMMON/MODEL/ NE,TEMP,PE,NATOM 
C                   
      COMMON/OPAC/ M,RHO,CHIE,SIG,                    
     ,FREQ,WT,PHOTO,NXTION,BNU
C                  
      COMMON/POPUL/ HTOT,NHYD,NP
                         
      EQUIVALENCE(V(2000),NELEM(1)),(V(2001),ELMENT(1)),                
     ,(V(2026),ALFA(1)),(V(2051),AS(1)),(V(2076),CHIO(1))               
      EQUIVALENCE (V(2101),NBELO1(1)),(V(2151),NTO1(1))                 
      EQUIVALENCE (V(2201),KU(1)),(V(2202),TO1(1)),(V(2450),UO1(1))     
      EQUIVALENCE (V(2698),KEL(1)),(V(2699),NLEVEL(1)),                 
     ,(V(2759),EXO1(1)),(V(2789),GO1(1))           
C 
C       PRINT *,'start STATPM'                                    
      DATA NLH/5/,XK/1.38054E-16/                                      
      KBO=0                                                             
      ID=IDEP                                                           
      ELPRES=PE(ID)                                                     
      T=TEMP(ID)                                                        
      THETA=5040./T                                                     
      Z=2.5*ALOG10(T)                                                   
      Q=0.0                                                             
      SUM=0.0                                                           
      ALF=0.0                                                           
      XMU=0.0                                                           
      NTO=0                                                             
C      NLM=NELEM(1)                                                     
C      DO 16 IE=1,NLM       
      DO 16 IE=1,NELEM(1)                                                
           QI(IE)=0.0 
C           PRINT *,IE,ALFA(IE)
C           ASA=AS(IE)*ALFA(IE) 
C           PRINT *,ASA                                                
      XMU=AS(IE)*ALFA(IE)+XMU                                           
      ALF=ALF+ALFA(IE)                                                  
      DO 2 IO=1,2                                                       
      NTE=NTO1(IO,IE)                                                   
      NB=NBELO1(IO,IE)+KBO                                              
      IF(NTE.GT.1) GO TO 5                                             
      NTO=NTO+1                                                        
   40 U(IO)=UO1(NTO)                                                    
      GO TO 6                                                           
   95 PRLOG=2.0/U(2)                                                    
      GO TO 995                                                         
    5 DO 4 IT=1,NTE                                                     
      NTO=NTO+1                                                        
      TO(IT)=TO1(NTO)                                                  
      UO(IT)=UO1(NTO)                                                
    4 CONTINUE                                                        
      CALL LININT(TO,UO,NTE,25)                                       
      CALL EVAL(T,U(IO))                                               
      UU=U(IO)                                                        
    6 IF(NBELO1(IO,IE).EQ.0) GO TO 2                                 
   50 DB=0.0                                                         
      KBO=KBO+1                                                       
      DO 8 IB=KBO,NB                                                   
      DB=(BM(ID,IB)-1.0)*GO1(IB)*EXP(-EXO1(IB)/                      
     ,0.8616E-4/T)+DB                                                  
    8 CONTINUE                                                       
      U(IO)=U(IO)+DB                                                  
      KBO=NB                                                          
    2 CONTINUE                                                        
      IF(IE.EQ.1) GO TO 10                                            
   60 PRLOG=2.0*U(2)/U(1)                                            
      PRLOG=ALOG10(PRLOG)                                              
      QA(IE)=-CHIO(IE)*THETA+Z-0.4772+PRLOG                           
      QA(IE)=10.0**QA(IE)/ELPRES                                      
      QI(IE)=ALFA(IE)*QA(IE)/(1.0+QA(IE))                              
           Q=Q+QI(IE)                                                 
      SUM=SUM+ALFA(IE)                                                
      GO TO 16                                                        
   10 PRLOG=2.0*U(1)/U(2)                                               
      PRLOG=ALOG10(PRLOG)                                            
      QHM=-0.7552*THETA+Z+0.1249-PRLOG                                
      IF(NBELO1(2,1).EQ.0) GO TO 95                                   
      J=NBELO1(1,1)+1                                                 
      PRLOG=2.0*BM(ID,J)/U(2)                                         
  995 CONTINUE                                                        
      PRLOG=ALOG10(PRLOG)                                               
      QH2=12.533505+(-4.9251644+5.6191273E-02*THETA-                  
     ,3.268766E-03*THETA**2)*THETA-2.0*PRLOG                         
      QH2P=11.206998+(-2.7942767-7.9196803E-02*THETA+                   
     ,2.4790744E-02*THETA**2)*THETA-PRLOG                             
      QHM=10.0**QHM                                                    
      QH2=10.0**QH2                                                   
      QH2P=10.0**QH2P                                                 
      QH=0.0                                                         
      DO 15 I=1,16                                                   
      IF(I.GT.NBELO1(2,1)) GO TO 12                                   
   70 IJ=I+NBELO1(1,1)                                                
      BN=BM(ID,IJ)                                                  
   13 AI2=FLOAT(I*I)                                                  
      QHN=ALOG10(BN)+ALOG10(AI2)+0.4772-Z+13.595*                    
     ,THETA/AI2                                                      
      QHN=10.0**QHN                                                   
      QH=QH+QHN                                                      
      IF (I.GT.NLH) GO TO 15                                        
      NHYD(I,ID)=ELPRES*QHN                                         
      GO TO 15                                                       
   12 BN=1.0                                                         
      GO TO 13                                                       
   15 CONTINUE                                                       
      UHYD=ELPRES*QH                                                 
   16 CONTINUE                                                        
      XMU=XMU/AS(1)                                                  
      G2=1.0/UHYD                                                   
      G3=ELPRES/QHM                                                  
      F1=1.0/(1.+G2+G3)                                             
      F4=0.0                                                          
      F5=0.0                                                        
      IF(IHTOT.EQ.1) GO TO 20                                         
      IF(IHTOT.EQ.2) GO TO 22                                         
      WRITE(6,99999) IHTOT                                           
99999 FORMAT('0 WRONG IHTOT=',I5)                                     
   22 G4=ELPRES/QH2P                                                
      G5=ELPRES/QH2                                                
      AA=1.0+G2+G3                                                 
      D=G2-G3                                                      
      E=G2*(G4/G5)                                                    
      BB=2.0*(1.0+E)                                                 
      C1=G5*BB**2+AA*D*BB-E*AA**2                                    
      C2=2.0*AA*E-D*BB+AA*BB*Q                                   
      C3=-(E+BB*Q)                                                    
      F1=(-C2+DSQRT(C2*C2-4.0*C3*C1))/(2.0*C1)                        
      F5=(1.0-AA*F1)/BB                                              
      F4=E*F5                                                       
   20 F3=G3*F1                                                        
      F2=G2*F1                                                      
      FZE=F2-F3+F4+Q                                                
         DH(ID)=F2/FZE                                                
        DHM(ID)=-1.*F3/FZE                                           
       DH2P(ID)=F4/FZE                                              
      YGE=1.0+(F1+F2+F3+F4+F5+SUM)/FZE                                
      FH=F1                                                           
      R1=F1/FZE                                                     
       Y=1.+G2+G3                                                    
      IF(IHTOT.EQ.1) GO TO 21                                         
      IF(IHTOT.EQ.2) GO TO 23                                     
        WRITE(6,99999) IHTOT                                         
   23 Y=1.0+G2+G3+2.0*G5*R1+2.0*G2*G4*R1                            
   21 HNUM=HTOT(ID)/Y                                              
      HPNUM=HNUM*G2                                                    
      NP(ID)=HPNUM                                                 
      YHNUM=HTOT(ID)                                                
      NE(ID)=ELPRES/(XK*T)                                          
      DO 3 IL=1,NLH                                                 
      NHYD(IL,ID)=HPNUM*NHYD(IL,ID)                                
    3 CONTINUE                                                      
   33 Y=XK*T/ELPRES                                               
C        PRINT *,'statpm RHO =',RHO(ID)
        
C
C      PRINT 55,ID,T,HTOT(ID),F1,F2,F3,F4,F5,Q                        
C     IF(ID.EQ.1) PRINT 5500,ALF                                     
 5500 FORMAT('0 ALFA=',F15.5)                                       
   55 FORMAT(I5,F8.1,E15.7,6E10.3)                                        
C        DO 90 IE=2,NLM
        DO 90 IE=2,NELEM(1) 
        DQI(IE,ID)=QI(IE)/FZE
   90   CONTINUE
        DQ(ID)=Q/FZE
C               PRINT *,'end STATPM'   
      RETURN                                                         
      END                                                      
