program mcmc_ann
use global_vars_mod, only : verbose_level, prior, chain
use chain_analysis_mod
use multinest_mod, only : do_multinest
use config_mod, only : initialize_problem
implicit none

real(kind=8) :: dum
character(len=128) :: inputfile
integer :: nargs
	
	call init_random_seed()
	
	verbose_level = 2
	
! Initialize problem
	inputfile = 'conf.input'

! Verify if a configuration file is passed as an argument
! If not, use the default 'config' file
	nargs = iargc()
	if (nargs == 1) then
   	call getarg(1,inputfile)
	endif

!****************
! Initialize problem
!****************
 	call initialize_problem(inputfile, chain, prior)

!****************
! Do sampling
!****************
  	call do_multinest(chain, prior, .TRUE.)

!****************
! Analyze sampling
!****************
 	call analyze_chains_multinest(chain, prior)
			
end program mcmc_ann