module types_mod
Use Model_structure, only : Model
implicit none
	
	type observations_type
		integer :: npoints
		character(len=128) :: filename, description
		real(kind=8), pointer :: obs_x(:), obs_y(:,:), obs_sigma(:,:), model_eval(:,:)
	end type observations_type
	
	type prior_type
		integer :: nparam
		integer, pointer :: typ(:)
		real(kind=8), pointer :: sigma(:), mu(:), minim(:), maxim(:)
		character(len=40), pointer :: param_names(:)
	end type prior_type

	type markov_chain_type		
		integer :: nparam, accepted_models, initial, niter_max, nlength, nparam_not_ffs, ncalls
		real(kind=8) :: best_likelihood
		real(kind=8), pointer :: proposed(:), last(:), most_probable(:)
		real(kind=8), pointer :: chain(:,:), mean(:), mean_old(:), covariance(:,:)
		real(kind=8), pointer :: posterior(:), acceptance_rate(:), best_parameters(:)
		real(kind=8) :: flast, fmax, alpha, burnin, avg_lnL, evidence
		character(len=128) :: filename
		character(len=40), pointer :: param_names(:)
		type(observations_type) :: observation
	end type markov_chain_type

	type model_type
		integer :: ncomponents, n_free_parameters_total
		integer, pointer :: n_free_parameters_per_component(:)
		character(len=128), pointer :: filename(:)
		integer, pointer :: n_nodes(:,:), pos_nodes(:,:,:)
		real(kind=8), pointer :: value_nodes(:,:,:), ff(:)
		type(prior_type), pointer :: priors(:)
		type(Model), pointer :: perturbed(:)
		type(Model), pointer :: stratification(:)
	end type model_type
		
end module types_mod