Module Line_data_structure
!
  Type Line_data
     Integer :: Mult_low, Mult_up, index
     Character :: Desig_low, Desig_up
     Real :: J_low, J_up
     Real :: Wlength ! in Angstroms
     Real :: Width ! in Angstroms. Roughly (estimate by excess to be safe)
     Real :: VDW_enh, Energy_low, loggf ! Energy in eV
     Integer :: Atomic_number, Ion_stage ! Z and ionization stage
     Real :: Atomic_weight
     Integer :: collisions ! Treatment for collisions with neutral H:
                           !    1->Unsold formula
                           !    2->Use Barklem coefficients
     Real :: Bark_alpha, Bark_sigma ! Barklem coefficients
     Integer :: NLTEtransition ! Number of transition in the NLTE ATOM 
                               !  If this line is LTE, set to zero
     Real :: NLTE_nl_ratio ! Ratio of lower level populations for the line
                           ! of interest to the population in the NLTE 
                           ! computation (useful, e.g. to synthesize
                           ! multiplet components
     Real :: NLTE_nu_ratio ! Same as above for the upper level
     Integer :: NLTEgridsize ! Size of wavelength grid for NLTE computation
     Real, Dimension(:), Allocatable :: NLTEgrid
     Real, Dimension(:,:), Allocatable :: NLTESource_f
     Real, Dimension(:), Allocatable :: b_low, b_up
  End Type Line_data
!
  Type Region_data
     Real :: First_wlength ! in Angstroms
     Real :: Wave_step ! in Angstroms
     Real :: Macro_enh ! Macroturbulence enhancement factor (dimensionless)
     Integer :: nwavelengths ! number of wavelengths
     Integer :: layer ! 1->Photospheric region; 2->Chromospheric region
  End Type Region_data
!
End Module Line_data_structure
