module global_vars_mod
use types_mod
Use Line_data_structure, only : Line_data, Region_data
Use Param_structure, only : Parameters
implicit none
					
	type(markov_chain_type) :: chain
	type(prior_type) :: prior
	type(observations_type) :: obs
	type(transmission_filter_type) :: filter
	
	integer :: verbose_level, what_to_do, observation_mode

	real(kind=8), parameter :: one_sigma = 68.268955d0, &
		two_sigma = 95.449972d0, PI=3.14159265359d0, CLIGHT = 2.99792458d10

	type(Line_data), pointer :: Line(:)
   type(Region_data), pointer :: Region(:)
   type(model_type) :: atmos
   type(Parameters) :: Params

   logical :: Hydro, Error

   real, allocatable :: Stokes_Syn(:), Stokes_Tot(:)

   integer, parameter :: n_param_per_component = 7

!evidence tolerance factor
   real(kind=8) :: nest_tol
      
!enlargement factor reduction parameter
	real(kind=8) :: nest_efr

!max modes expected, for memory allocation
  	integer nest_maxModes

! Number of live points
	integer :: nest_nlive
   
end module global_vars_mod
